/*
 * java-gnome, a UI library for writing GTK and GNOME programs from Java!
 *
 * Copyright © 2006-2012 Operational Dynamics Consulting, Pty Ltd and Others
 *
 * The code in this file, and the program it is a part of, is made available
 * to you by its authors as open source software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License version
 * 2 ("GPL") as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GPL for more details.
 *
 * You should have received a copy of the GPL along with this program. If not,
 * see http://www.gnu.org/licenses/. The authors of this program may be
 * contacted through http://java-gnome.sourceforge.net/.
 *
 * Linking this library statically or dynamically with other modules is making
 * a combined work based on this library. Thus, the terms and conditions of
 * the GPL cover the whole combination. As a special exception (the
 * "Classpath Exception"), the copyright holders of this library give you
 * permission to link this library with independent modules to produce an
 * executable, regardless of the license terms of these independent modules,
 * and to copy and distribute the resulting executable under terms of your
 * choice, provided that you also meet, for each linked independent module,
 * the terms and conditions of the license of that module. An independent
 * module is a module which is not derived from or based on this library. If
 * you modify this library, you may extend the Classpath Exception to your
 * version of the library, but you are not obligated to do so. If you do not
 * wish to do so, delete this exception statement from your version.
 */

/*
 * THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gdk_GdkEvent.h"

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkEvent_gdk_1event_1put
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkEvent* self;

	// convert parameter self
	self = (GdkEvent*) _self;

	// call function
	gdk_event_put(self);

	// cleanup parameter self
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gdk_GdkEvent_gdk_1event_1new
(
	JNIEnv* env,
	jclass cls,
	jint _type
)
{
	GdkEvent* result;
	jlong _result;
	GdkEventType type;

	// convert parameter type
	type = (GdkEventType) _type;

	// call function
	result = gdk_event_new(type);

	// cleanup parameter type

	// translate return value to JNI type
	_result = (jlong) result;

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gdk_GdkEvent_gdk_1event_1copy
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkEvent* result;
	jlong _result;
	GdkEvent* self;

	// convert parameter self
	self = (GdkEvent*) _self;

	// call function
	result = gdk_event_copy(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkEvent_gdk_1event_1free
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkEvent* self;

	// convert parameter self
	self = (GdkEvent*) _self;

	// call function
	gdk_event_free(self);

	// cleanup parameter self
}

JNIEXPORT jint JNICALL
Java_org_gnome_gdk_GdkEvent_gdk_1event_1get_1time
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	guint32 result;
	jint _result;
	GdkEvent* self;

	// convert parameter self
	self = (GdkEvent*) _self;

	// call function
	result = gdk_event_get_time(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gdk_GdkEvent_gdk_1event_1get_1state
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jintArray _state
)
{
	gboolean result;
	jboolean _result;
	GdkEvent* self;
	GdkModifierType* state;

	// convert parameter self
	self = (GdkEvent*) _self;

	// convert parameter state
	state = (GdkModifierType*) (*env)->GetIntArrayElements(env, _state, NULL);
	if (state == NULL) {
		return  JNI_FALSE; // Java Exception already thrown
	}

	// call function
	result = gdk_event_get_state(self, state);

	// cleanup parameter self

	// cleanup parameter state
	(*env)->ReleaseIntArrayElements(env, _state, (jint*)state, 0);

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gdk_GdkEvent_gdk_1event_1get_1coords
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jdoubleArray _xWin,
	jdoubleArray _yWin
)
{
	gboolean result;
	jboolean _result;
	GdkEvent* self;
	gdouble* xWin;
	gdouble* yWin;

	// convert parameter self
	self = (GdkEvent*) _self;

	// convert parameter xWin
	xWin = (gdouble*) (*env)->GetDoubleArrayElements(env, _xWin, NULL);
	if (xWin == NULL) {
		return  JNI_FALSE; // Java Exception already thrown
	}

	// convert parameter yWin
	yWin = (gdouble*) (*env)->GetDoubleArrayElements(env, _yWin, NULL);
	if (yWin == NULL) {
		return  JNI_FALSE; // Java Exception already thrown
	}

	// call function
	result = gdk_event_get_coords(self, xWin, yWin);

	// cleanup parameter self

	// cleanup parameter xWin
	(*env)->ReleaseDoubleArrayElements(env, _xWin, (jdouble*)xWin, 0);

	// cleanup parameter yWin
	(*env)->ReleaseDoubleArrayElements(env, _yWin, (jdouble*)yWin, 0);

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gdk_GdkEvent_gdk_1event_1get_1root_1coords
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jdoubleArray _xRoot,
	jdoubleArray _yRoot
)
{
	gboolean result;
	jboolean _result;
	GdkEvent* self;
	gdouble* xRoot;
	gdouble* yRoot;

	// convert parameter self
	self = (GdkEvent*) _self;

	// convert parameter xRoot
	xRoot = (gdouble*) (*env)->GetDoubleArrayElements(env, _xRoot, NULL);
	if (xRoot == NULL) {
		return  JNI_FALSE; // Java Exception already thrown
	}

	// convert parameter yRoot
	yRoot = (gdouble*) (*env)->GetDoubleArrayElements(env, _yRoot, NULL);
	if (yRoot == NULL) {
		return  JNI_FALSE; // Java Exception already thrown
	}

	// call function
	result = gdk_event_get_root_coords(self, xRoot, yRoot);

	// cleanup parameter self

	// cleanup parameter xRoot
	(*env)->ReleaseDoubleArrayElements(env, _xRoot, (jdouble*)xRoot, 0);

	// cleanup parameter yRoot
	(*env)->ReleaseDoubleArrayElements(env, _yRoot, (jdouble*)yRoot, 0);

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gdk_GdkEvent_gdk_1event_1get_1axis
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _axisUse,
	jdoubleArray _value
)
{
	gboolean result;
	jboolean _result;
	GdkEvent* self;
	GdkAxisUse axisUse;
	gdouble* value;

	// convert parameter self
	self = (GdkEvent*) _self;

	// convert parameter axisUse
	axisUse = (GdkAxisUse) _axisUse;

	// convert parameter value
	value = (gdouble*) (*env)->GetDoubleArrayElements(env, _value, NULL);
	if (value == NULL) {
		return  JNI_FALSE; // Java Exception already thrown
	}

	// call function
	result = gdk_event_get_axis(self, axisUse, value);

	// cleanup parameter self

	// cleanup parameter axisUse

	// cleanup parameter value
	(*env)->ReleaseDoubleArrayElements(env, _value, (jdouble*)value, 0);

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkEvent_gdk_1event_1set_1screen
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _screen
)
{
	GdkEvent* self;
	GdkScreen* screen;

	// convert parameter self
	self = (GdkEvent*) _self;

	// convert parameter screen
	screen = (GdkScreen*) _screen;

	// call function
	gdk_event_set_screen(self, screen);

	// cleanup parameter self

	// cleanup parameter screen
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gdk_GdkEvent_gdk_1event_1get_1screen
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkScreen* result;
	jlong _result;
	GdkEvent* self;

	// convert parameter self
	self = (GdkEvent*) _self;

	// call function
	result = gdk_event_get_screen(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}
