/*
 * java-gnome, a UI library for writing GTK and GNOME programs from Java!
 *
 * Copyright © 2006-2012 Operational Dynamics Consulting, Pty Ltd and Others
 *
 * The code in this file, and the program it is a part of, is made available
 * to you by its authors as open source software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License version
 * 2 ("GPL") as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GPL for more details.
 *
 * You should have received a copy of the GPL along with this program. If not,
 * see http://www.gnu.org/licenses/. The authors of this program may be
 * contacted through http://java-gnome.sourceforge.net/.
 *
 * Linking this library statically or dynamically with other modules is making
 * a combined work based on this library. Thus, the terms and conditions of
 * the GPL cover the whole combination. As a special exception (the
 * "Classpath Exception"), the copyright holders of this library give you
 * permission to link this library with independent modules to produce an
 * executable, regardless of the license terms of these independent modules,
 * and to copy and distribute the resulting executable under terms of your
 * choice, provided that you also meet, for each linked independent module,
 * the terms and conditions of the license of that module. An independent
 * module is a module which is not derived from or based on this library. If
 * you modify this library, you may extend the Classpath Exception to your
 * version of the library, but you are not obligated to do so. If you do not
 * wish to do so, delete this exception statement from your version.
 */

/*
 * THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkCellView.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkCellView_gtk_1cell_1view_1new
(
	JNIEnv* env,
	jclass cls
)
{
	GtkWidget* result;
	jlong _result;

	// call function
	result = gtk_cell_view_new();

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkCellView_gtk_1cell_1view_1set_1model
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _model
)
{
	GtkCellView* self;
	GtkTreeModel* model;

	// convert parameter self
	self = (GtkCellView*) _self;

	// convert parameter model
	model = (GtkTreeModel*) _model;

	// call function
	gtk_cell_view_set_model(self, model);

	// cleanup parameter self

	// cleanup parameter model
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkCellView_gtk_1cell_1view_1set_1displayed_1row
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _path
)
{
	GtkCellView* self;
	GtkTreePath* path;

	// convert parameter self
	self = (GtkCellView*) _self;

	// convert parameter path
	path = (GtkTreePath*) _path;

	// call function
	gtk_cell_view_set_displayed_row(self, path);

	// cleanup parameter self

	// cleanup parameter path
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkCellView_gtk_1cell_1view_1get_1displayed_1row
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkTreePath* result;
	jlong _result;
	GtkCellView* self;

	// convert parameter self
	self = (GtkCellView*) _self;

	// call function
	result = gtk_cell_view_get_displayed_row(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkCellView_gtk_1cell_1view_1get_1size_1of_1row
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _path,
	jlong _requisition
)
{
	gboolean result;
	jboolean _result;
	GtkCellView* self;
	GtkTreePath* path;
	GtkRequisition* requisition;

	// convert parameter self
	self = (GtkCellView*) _self;

	// convert parameter path
	path = (GtkTreePath*) _path;

	// convert parameter requisition
	requisition = (GtkRequisition*) _requisition;

	// call function
	result = gtk_cell_view_get_size_of_row(self, path, requisition);

	// cleanup parameter self

	// cleanup parameter path

	// cleanup parameter requisition

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkCellView_gtk_1cell_1view_1set_1background_1rgba
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _color
)
{
	GtkCellView* self;
	const GdkRGBA* color;

	// convert parameter self
	self = (GtkCellView*) _self;

	// convert parameter color
	color = (const GdkRGBA*) _color;

	// call function
	gtk_cell_view_set_background_rgba(self, color);

	// cleanup parameter self

	// cleanup parameter color
}
