/*
 * java-gnome, a UI library for writing GTK and GNOME programs from Java!
 *
 * Copyright © 2006-2012 Operational Dynamics Consulting, Pty Ltd and Others
 *
 * The code in this file, and the program it is a part of, is made available
 * to you by its authors as open source software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License version
 * 2 ("GPL") as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GPL for more details.
 *
 * You should have received a copy of the GPL along with this program. If not,
 * see http://www.gnu.org/licenses/. The authors of this program may be
 * contacted through http://java-gnome.sourceforge.net/.
 *
 * Linking this library statically or dynamically with other modules is making
 * a combined work based on this library. Thus, the terms and conditions of
 * the GPL cover the whole combination. As a special exception (the
 * "Classpath Exception"), the copyright holders of this library give you
 * permission to link this library with independent modules to produce an
 * executable, regardless of the license terms of these independent modules,
 * and to copy and distribute the resulting executable under terms of your
 * choice, provided that you also meet, for each linked independent module,
 * the terms and conditions of the license of that module. An independent
 * module is a module which is not derived from or based on this library. If
 * you modify this library, you may extend the Classpath Exception to your
 * version of the library, but you are not obligated to do so. If you do not
 * wish to do so, delete this exception statement from your version.
 */

/*
 * THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include <gtk/gtkunixprint.h>
#include "bindings_java.h"
#include "org_gnome_unixprint_GtkPrinter.h"

JNIEXPORT jstring JNICALL
Java_org_gnome_unixprint_GtkPrinter_gtk_1printer_1get_1name
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	const gchar* result;
	jstring _result;
	GtkPrinter* self;

	// convert parameter self
	self = (GtkPrinter*) _self;

	// call function
	result = gtk_printer_get_name(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jstring) bindings_java_newString(env, result);

	// and finally
	return _result;
}

JNIEXPORT jstring JNICALL
Java_org_gnome_unixprint_GtkPrinter_gtk_1printer_1get_1state_1message
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	const gchar* result;
	jstring _result;
	GtkPrinter* self;

	// convert parameter self
	self = (GtkPrinter*) _self;

	// call function
	result = gtk_printer_get_state_message(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jstring) bindings_java_newString(env, result);

	// and finally
	return _result;
}

JNIEXPORT jstring JNICALL
Java_org_gnome_unixprint_GtkPrinter_gtk_1printer_1get_1description
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	const gchar* result;
	jstring _result;
	GtkPrinter* self;

	// convert parameter self
	self = (GtkPrinter*) _self;

	// call function
	result = gtk_printer_get_description(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jstring) bindings_java_newString(env, result);

	// and finally
	return _result;
}

JNIEXPORT jstring JNICALL
Java_org_gnome_unixprint_GtkPrinter_gtk_1printer_1get_1location
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	const gchar* result;
	jstring _result;
	GtkPrinter* self;

	// convert parameter self
	self = (GtkPrinter*) _self;

	// call function
	result = gtk_printer_get_location(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jstring) bindings_java_newString(env, result);

	// and finally
	return _result;
}

JNIEXPORT jstring JNICALL
Java_org_gnome_unixprint_GtkPrinter_gtk_1printer_1get_1icon_1name
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	const gchar* result;
	jstring _result;
	GtkPrinter* self;

	// convert parameter self
	self = (GtkPrinter*) _self;

	// call function
	result = gtk_printer_get_icon_name(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jstring) bindings_java_newString(env, result);

	// and finally
	return _result;
}

JNIEXPORT jint JNICALL
Java_org_gnome_unixprint_GtkPrinter_gtk_1printer_1get_1job_1count
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gint result;
	jint _result;
	GtkPrinter* self;

	// convert parameter self
	self = (GtkPrinter*) _self;

	// call function
	result = gtk_printer_get_job_count(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_unixprint_GtkPrinter_gtk_1printer_1is_1active
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkPrinter* self;

	// convert parameter self
	self = (GtkPrinter*) _self;

	// call function
	result = gtk_printer_is_active(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_unixprint_GtkPrinter_gtk_1printer_1is_1virtual
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkPrinter* self;

	// convert parameter self
	self = (GtkPrinter*) _self;

	// call function
	result = gtk_printer_is_virtual(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_unixprint_GtkPrinter_gtk_1printer_1is_1default
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkPrinter* self;

	// convert parameter self
	self = (GtkPrinter*) _self;

	// call function
	result = gtk_printer_is_default(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_unixprint_GtkPrinter_gtk_1printer_1accepts_1pdf
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkPrinter* self;

	// convert parameter self
	self = (GtkPrinter*) _self;

	// call function
	result = gtk_printer_accepts_pdf(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_unixprint_GtkPrinter_gtk_1printer_1accepts_1ps
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkPrinter* self;

	// convert parameter self
	self = (GtkPrinter*) _self;

	// call function
	result = gtk_printer_accepts_ps(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jint JNICALL
Java_org_gnome_unixprint_GtkPrinter_gtk_1printer_1compare
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _b
)
{
	gint result;
	jint _result;
	GtkPrinter* self;
	GtkPrinter* b;

	// convert parameter self
	self = (GtkPrinter*) _self;

	// convert parameter b
	b = (GtkPrinter*) _b;

	// call function
	result = gtk_printer_compare(self, b);

	// cleanup parameter self

	// cleanup parameter b

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT jint JNICALL
Java_org_gnome_unixprint_GtkPrinter_gtk_1printer_1get_1capabilities
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkPrintCapabilities result;
	jint _result;
	GtkPrinter* self;

	// convert parameter self
	self = (GtkPrinter*) _self;

	// call function
	result = gtk_printer_get_capabilities(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_unixprint_GtkPrinter_gtk_1printer_1has_1details
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkPrinter* self;

	// convert parameter self
	self = (GtkPrinter*) _self;

	// call function
	result = gtk_printer_has_details(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_unixprint_GtkPrinter_gtk_1printer_1request_1details
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkPrinter* self;

	// convert parameter self
	self = (GtkPrinter*) _self;

	// call function
	gtk_printer_request_details(self);

	// cleanup parameter self
}
